package com.zcloud.primeport.web;


import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import com.zcloud.primeport.api.PersonMessageServiceI;
import com.zcloud.primeport.dto.PersonMessageAddCmd;
import com.zcloud.primeport.dto.PersonMessagePageQry;
import com.zcloud.primeport.dto.PersonMessageUpdateCmd;
import com.zcloud.primeport.dto.clientobject.PersonMessageCO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;

/**
 * web-adapter
 *
 * @Author makejava
 * @Date 2026-03-05 11:33:20
 */
@Api(tags = "审批通过的人员信息用于与门禁系统对接")
@RequestMapping("/${application.gateway}/personMessage")
@RestController
@AllArgsConstructor
public class PersonMessageController {
    private final PersonMessageServiceI personMessageService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<PersonMessageCO> add(@Validated @RequestBody PersonMessageAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        return personMessageService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<PersonMessageCO> page(@RequestBody PersonMessagePageQry qry) {
        return personMessageService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<PersonMessageCO> listAll() {
        return MultiResponse.of(new ArrayList<PersonMessageCO>());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<PersonMessageCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(new PersonMessageCO());
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        personMessageService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        personMessageService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody PersonMessageUpdateCmd personMessageUpdateCmd) {
        personMessageService.edit(personMessageUpdateCmd);
        return SingleResponse.buildSuccess();
    }
}

